local Tinkr, Bastion = ...

---@class MythicPlusUtils
local MythicPlusUtils = {
    interruptList = {},
}

MythicPlusUtils.__index = MythicPlusUtils

---@return MythicPlusUtils
function MythicPlusUtils:New()
    local self = setmetatable({}, MythicPlusUtils)

    self.interruptList = {
        -- kick, stun, disorient, incap
        --
        -- Hals of Valor
        --
            -- Thunder Caller
        [95842] = {
            -- Thunderous Blast
            [198585] = {
                true, true, true, true
            }
        },
            -- Mystic
        [95834] = {
            -- Holy Radiance
            [215433] = {
                true, true, true, true
            }
        },
            -- Runcarver
        [96664] = {
            -- Etch
            [198959] = {
                true, true, true, true
            }
        },
            -- Marksman
        [96640] = {
            -- Penetrating Shot
            [199210] = {
                false, true, true, true
            }
        },
            -- Shieldmaiden
        [95832] = {
            -- Mortal Hew
            [199050] = {
                false, true, true, false
            }
        },
            -- Shieldmaiden 2
        [101639] = {
            -- Mortal Hew
            [199050] = {
                false, true, false, false
            }
        },
            -- Odyn Add
        [102019] = {
            -- Surge
            [198750] = {
                true, false, false, false
            }
        },
        --
        -- Court of Stars
        --
            -- Duskwatch Guard
        [111563] = {
            -- Fortification
            [209033] = {
                true, true, true
            }
        },
            -- Duskwatch Guard 2
        [104246] = {
            -- Fortification
            [209033] = {
                true, true, false, false
            }
        },
            -- Sentry
        [104251] = {
            -- Sound the Alarm
            [210261] = {
                true, true, true, true
            }
        },
            -- Construct
        [104270] = {
            -- Suppress
            [209413] = {
                true, false, false, false
            },
            -- Charging Station
            [225100] = {
                true, false, false
            }
        },
            -- Bound Energy
        [105705] = {
            -- Charged Blast
            [212031] = {
                true, true, false, false
            }
        },
            -- Arcane Manifestation
        [105704] = {
            -- Drain Magic
            [209485] = {
                true, false, false, false
            }
        },
            -- Watchful Inquisitor
        [105715] = {
            -- Searing Glare
            [211299] = {
                true, false, false, false
            },
            -- Eye Storm
            [212784] = {
                false, true, false, false
            }
        },
            -- Blazing Imp
        [104295] = {
            -- Drifting Embers
            [211401] = {
                true, true, true, false
            },
            -- Drifting Embers 2
            [211406] = {
                true, true, true, false
            },
            -- Fireball
            [211412] = {
                true, true, true, false
            }
        },
            -- Shadow Mistress
        [104300] = {
            -- Bewitch
            [211470] = {
                true, true, true, false
            }
        },
            -- Balgarr
        [104274] = {
            -- Disintegration Beam
            [207980] = {
                true, false, false, false
            },
            -- Disintigration Beam 2
            [207981] = {
                true, false, false, false
            },
            -- Impending Doom
            [397907] = {
                true, false, false, false
            },
            -- Impending Doom 2
            [397908] = {
                true, false, false, false
            }
        },
            -- Talixae Flamewreath
        [104217] = {
            -- Withering Soul
            [208165] = {
                true, false, false, false
            }
        },
        --
        -- RLP
        --
            -- Earthshaper
        [187969] = {
            -- Tectonic Slam
            [372735] = {
                false, true, true, true
            }
        },
            -- Chillweaver
        [188067] = {
            -- Ice Shield
            [384933] = {
                true, true, true, true
            },
            -- Ice Shield 2
            [372749] = {
                true, true, true, true
            },
            -- Ice Shield 3
            [372743] = {
                true, true, true, true
            }
        },
            -- Meledrusa
        [188252] = {
            -- Frost Overload
            [373680] = {
                true, false, false, false
            },
            -- Frost Overload 2
            [373688] = {
                true, false, false, false
            }
        },
            -- Cinderweaver
        [190207] = {
            -- Cinderbolt 1
            [384194] = {
                true, false, false, false
            },
            -- Cinderbolt 2
            [384197] = {
                true, false, false, false
            }
        },
            -- Flame Dancer
        [190206] = {
            -- Flame Dance
            [385536] = {
                false, true, true, true
            }
        },
            -- Blazebound Firestorm
        [189886] = {
            -- Roaring Blaze
            [373017] = {
                true, false, false, false
            }
        },
            -- Tempest Channeler
        [198047] = {
            -- Thunder Bolt
            [392576] = {
                true, false, false, false
            }
        },
            -- Flame Channeler
        [197985] = {
            -- Flashfire
            [392451] = {
                true, true, false, false
            },
            -- Flashfire
            [392452] = {
                true, true, false, false
            },
        },
        --
        -- NO
        --
            -- Hornsounder
        [192796] = {
            -- Rally The Clan
            [383823] = {
                false, true, true, true
            }
        },
            -- Plainstomper
        [191847] = {
            -- Disruptive Shout
            [384365] = {
                true, false, false, false
            }
        },
            -- Lancemaster
        [192800] = {
            -- Disruptive Shout
            [384365] = {
                true, false, false, false
            }
        },
            -- Arcblade
        [194898] = {
            -- Arcing Strike
            [387135] = {
                false, true, true, true
            }
        },
            -- Stormcaller Botoo
        [194317] = {
            -- Stormbolt
            [386012] = {
                true, false, false, false
            }
        },
            -- Thunderbeast
        [195696] = {
            -- Chain Lightning
            [387127] = {
                true, false, false, false
            }
        },
        [194894] = {
            -- Tempest
            [386025] = {
                true, true, true, true
            },
            -- Tempest 2
            [386024] = {
                true, true, true, true
            },
            -- Summon Squall
            [386015] = {
                true, true, true, true
            },
            -- Stormbolt
            [386012] = {
                true, true, true, true
            }
        },
            -- Squall
        [194895] = {
            -- Surge
            [386026] = {
                true, true, false, false
            }
        },
            -- Stormcaller Arynga
        [195265] = {
            -- Stormbolt
            [386012] = {
                true, false, false, false
            }
        },
            -- Nokhud Neophyte
        [196263] = {
            -- Stormbolt
            [386012] = {
                true, true, false, false
            }
        },
            -- Stormcaller Solongo
        [194315] = {
            -- Stormbolt
            [386012] = {
                true, false, false, false
            }
        },
            -- Stormcaller Zarii
        [194316] = {
            -- Stormbolt
            [386012] = {
                true, false, false, false
            }
        },
            -- Soulharvester Galtmaa
        [195927] = {
            -- Death Bolt Volley
            [387411] = {
                true, false, false, false
            }
        },
            -- Soulharvester Tumen
        [195929] = {
            -- Death Bolt Volley
            [387411] = {
                true, false, false, false
            }
        },
            -- Soulharvester Mandakh
        [195930] = {
            -- Death Bolt Volley
            [387411] = {
                true, false, false, false
            }
        },
            -- Soulharvester Duuren
        [195928] = {
            -- Death Bolt Volley
            [387411] = {
                true, false, false, false
            }
        },
            -- Beastcaller
        [195878] = {
            -- Desecrated Roar
            [387440] = {
                true, true, true, true
            },
            -- Heavy Slash
            [387826] = {
                false, true, true, true
            }
        },
            -- Mystic
        [195877] = {
            -- Swift Wind
            [387596] = {
                true, true, true, false
            }
        },
            -- Risen Warrior
        [195855] = {
            -- Mortal Strike
            [388801] = {
                false, true, true, false
            }
        },
            -- Teera
        [186339] = {
            -- Guardian Wind
            [384808] = {
                true, false, false, false
            }
        },
            -- Batak
        [193462] = {
            -- Bloodcurdling Shout
            [373395] = {
                true, false, false, false
            }
        },
            -- Balakar Add
        [190294] = {
            -- Storm Bolt
            [376725] = {
                true, true, true, true
            }
        }
    }

    return self
end

---@param unit Unit
---@param percent number
---@return boolean
function MythicPlusUtils:CastingCriticalKick(unit, percent)
    local castingSpell = unit:GetCastingOrChannelingSpell()

    local npcSpells = self.interruptList[unit:GetID()]

    if npcSpells and castingSpell then
        local spellID = castingSpell:GetID()

        local spellTraits = npcSpells[spellID]

        if not spellTraits then
            return false
        end

        local isKick, isStun, isDisorient, isIncap = table.unpack(spellTraits)

        if isKick and unit:IsInterruptibleAt(percent) then
            return true
        end
    end

    return false
end

---@param unit Unit
---@param percent number
---@return boolean, boolean, boolean
function MythicPlusUtils:CastingCriticalStop(unit, percent)
    local castingSpell = unit:GetCastingOrChannelingSpell()

    local npcSpells = self.interruptList[unit:GetID()]

    if npcSpells and castingSpell then
        local spellID = castingSpell:GetID()

        local spellTraits = npcSpells[spellID]

        if not spellTraits then
            return false, false, false
        end

        local isKick, isStun, isDisorient, isIncap = table.unpack(spellTraits)

        local castPercent = unit:GetChannelOrCastPercentComplete()
        if (isStun or isDisorient or isIncap) and not isKick and castPercent >= percent then
            return isStun, isDisorient, isIncap
        end
    end

    return false, false, false
end

return MythicPlusUtils
